Subject: Re: [Patch] SIOCGIFCONF Win95
From: Corinna Vinschen <[email-masked]>
To: Alexander Gottwald <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Thu, 27 Sep 2001 12:47:13 +0200

On Thu, Sep 27, 2001 at 11:15:20AM +0200, Alexander Gottwald wrote:
> Hi,
> 
> On Win95, the implementation of SIOCGIFCONF seems to be wrong. For Win95a
> it seems to work, but Win95b and Win95c will onyl return the loopback 
> device. Searching through the code, I found the reason in winsup/cygwin/net.c 
> 
> in get_95_ifconf, the registry is searched for the key HKLM/Enum/MSTCP/*
> which seems to represent the TCP/IP configurations. The current 
> implementaion then searches for each entry the keys in Bindings, which 
> represent bindings to services as Client for Windows Networks or File
> sharing. One of these keys is taken as reference to HKLM/System/
> CurrentControlSet/Services/Class/Net/* where the network adapter is store.
> 
> This seems to work on Win95a, but does often fail on Win95c. The binding to 
> a service has IMO nothing to do with the binding to a NIC, so the connection
> to the NIC is stored in another way. Since there is a 1-to-1 relation between 
> network cards and TCP configuration, no extra binding needs to be stored. 
> The name for the adapter in HKLM/CurrentControlSet/.../Net is the same as
> the key in HKLM/Enum/Net/*. 
> 
> I modified the function in net.c and the correct number of interfaces is 
> reported for win95a and win95c.
> 
> I attached the patch. A patch cygwin1.dll is available at 
> <http://www.tu-chemnitz.de/~goal/xfree/cygwin1.fixed-netdev.dll.bz2>

Thanks Alexander, that looks good.  Unfortunately I can't apply that
patch if you haven't signed a copyright assignment form.  Your patch
isn't a `trivial' patch anymore which would allow us to include it
w/o the assignment.  Please have a look on http://cygwin.com/contrib.html. 
If you could send that assignment form via snail mail to Red Hat ASAP
(the address is given on the form), I will be really glad to apply your
patch.

Corinna

-- 
Corinna Vinschen                  Please, send mails regarding Cygwin to
Cygwin Developer                                mailto:[email-masked]
Red Hat, Inc.

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/